PROCEDURE COPY_64_64_8(DUMMY:DWORD);ASSEMBLER;
ASM
  MOV EAX,[PIXELS]
  SHR EAX,2
  XOR EDX,EDX
  MOV ESI,[BUFFER]
 @BIGLOOP:
  CMP EAX,16384
  JNA @RESTCOPY
  PUSH EAX
  PUSH EDX
  PUSH ESI
  MOV BX,WRWIN
  CALL SETBANK
  POP ESI
  POP EDX
  POP EAX
  MOV ECX,16384
  SUB EAX,ECX
  MOV EDI,[WRSEGL]
 @LP64:
  MOV EBX,[ESI]
  MOV FS:[EDI],EBX
  ADD ESI,4
  ADD EDI,4
  DEC ECX
  JNE @LP64
  INC EDX
  JMP @BIGLOOP
 @RESTCOPY:
  PUSH EAX
  PUSH EDX
  PUSH ESI
  MOV BX,WRWIN
  CALL SETBANK
  POP ESI
  POP DWORD PTR [OLDBANK]
  POP ECX
  MOV EDI,[WRSEGL]
 @LPR:
  MOV EBX,[ESI]
  MOV FS:[EDI],EBX
  ADD ESI,4
  ADD EDI,4
  DEC ECX
  JNE @LPR
END;
FUNCTION GET_64_64_8(X,Y:LONGINT):DWORD;ASSEMBLER;
ASM
  MOV ECX,X                    {                                            }
  CMP ECX,WIDTH                {  X-Position berprfen                     }
  JNB @EXT                     {                                            }
  MOV EDX,Y                    {                                            }
  CMP EDX,HEIGHT               {  Y-Position berprfen                     }
  JNB @EXT                     {                                            }
  MOV EAX,WIDTH                {                                            }
  MUL EDX                      {  Lineare Adresse im Bildschirmspeicher     }
  ADD EAX,ECX                  {  berechnen                                 }
  MOV EDX,EAX                  {                                            }
  SHR EDX,16                   {  Bank berprfen                           }
  CMP EDX,OLDBANK              {                                            }
  JZ @GOON                     {                                            }
  PUSH EAX                     {                                            }
  MOV OLDBANK,EDX              {  Bank setzen.                              }
  MOV BX,WRWIN                 {                                            }
  CALL SETBANK                 {                                            }
  POP EAX                      {                                            }
 @GOON:
  AND EAX,0FFFFh               { Lineare Adresse auf Bank-Offset reduzieren  }
  ADD EAX,[WRSEGL]             { Anfangsadresse des Bildschirmspeicher-F.    }
  MOV EAX,FS:[EAX]             { Und lesen                                   }
 @EXT:
END;
PROCEDURE PUT_64_64_8(X,Y:LONGINT;C:DWORD);ASSEMBLER;
ASM
  MOV ECX,X                    {                                            }
  CMP ECX,WIDTH                {  X-Position berprfen                     }
  JNB @EXT                     {                                            }
  MOV EDX,Y                    {                                            }
  CMP EDX,HEIGHT               {  Y-Position berprfen                     }
  JNB @EXT                     {                                            }
  MOV EAX,WIDTH                {                                            }
  MUL EDX                      {  Lineare Adresse im Bildschirmspeicher     }
  ADD EAX,ECX                  {  berechnen                                 }
  MOV EDX,EAX                  {                                            }
  SHR EDX,16                   {  Bank berprfen                           }
  CMP EDX,OLDBANK              {                                            }
  JZ @GOON                     {                                            }
  PUSH EAX                     {                                            }
  MOV OLDBANK,EDX              {  Bank setzen.                              }
  MOV BX,WRWIN                 {                                            }
  CALL SETBANK                 {                                            }
  POP EAX                      {                                            }
 @GOON:
  AND EAX,0FFFFh               { Lineare Adresse auf Bank-Offset reduzieren  }
  ADD EAX,[WRSEGL]             { Anfangsadresse des Bildschirmspeicher-F.    }
  MOV BL,BYTE PTR C            { Farbwert laden                              }
  MOV FS:[EAX],BL              { Und schreiben                               }
 @EXT:
END;
PROCEDURE BAR_B8(X,Y:LONGINT;H,B,C:DWORD);ASSEMBLER;
ASM
  MOV EAX,[VIS]
  OR EAX,EAX
  JZ @EXT
  MOV ESI,H
  OR ESI,ESI
  JZ NEAR @EXT
  MOV EBX,B
  OR EBX,EBX
  JZ NEAR @EXT
  MOV ECX,X
  SUB ECX,[SUBX]
  JNS @NXSIGN
  ADD EBX,ECX
  JS @EXT
  JZ @EXT
  XOR ECX,ECX
  JMP @XSIGN
 @NXSIGN:
  CMP ECX,[MAXX]
  JA @EXT
 @XSIGN:
  MOV EDX,Y
  SUB EDX,[SUBY]
  JNS @NYSIGN
  ADD ESI,EDX
  JS @EXT
  JZ @EXT
  XOR EDX,EDX
  JMP @YSIGN
 @NYSIGN:
  CMP EDX,[MAXY]
  JA @EXT
 @YSIGN:
  MOV EAX,ECX
  ADD EAX,EBX
  CMP EAX,[MAXX]
  JNA @NXOVER
  MOV EBX,[MAXX]
  SUB EBX,ECX
  INC EBX
 @NXOVER:
  MOV EAX,EDX
  ADD EAX,ESI
  CMP EAX,[MAXY]
  JNA @NYOVER
  MOV ESI,[MAXY]
  SUB ESI,EDX
  INC ESI
 @NYOVER:
  MOV EAX,[WIDTH]
  ADD EDX,[ADDY]
  MUL EDX
  ADD EAX,ECX
  ADD EAX,[ADDX]
  MOV EDI,EAX
  ADD EDI,[BUFFER]
  MOV EDX,[WIDTH]
  SUB EDX,EBX
  MOV EAX,C
 @MAINLOOP:
  MOV ECX,EBX
  REP STOSB
  ADD EDI,EDX
  DEC ESI
  JNE @MAINLOOP
 @EXT:
END;
FUNCTION GET_ABS_B8(X,Y:LONGINT):DWORD;ASSEMBLER;
ASM
  MOV ECX,X
  CMP ECX,[WIDTH]
  JNB @EXT
  MOV EDX,Y
  CMP EDX,[HEIGHT]
  JNB @EXT
  MOV EAX,[WIDTH]
  MUL EDX
  ADD EAX,ECX
  ADD EAX,[BUFFER]
  MOV EAX,[EAX]
 @EXT:
END;
PROCEDURE PUT_ABS_B8(X,Y:LONGINT;C:DWORD);ASSEMBLER;
ASM
  MOV ECX,X
  CMP ECX,[WIDTH]
  JNB @EXT
  MOV EDX,Y
  CMP EDX,[HEIGHT]
  JNB @EXT
  MOV EAX,[WIDTH]
  MUL EDX
  ADD EAX,ECX
  ADD EAX,[BUFFER]
  MOV EBX,[C]
  MOV [EAX],BL
 @EXT:
END;
FUNCTION GET_B8(X,Y:LONGINT):DWORD;ASSEMBLER;
ASM
  MOV EAX,[VIS]
  OR EAX,EAX
  JZ @EXT
  MOV ECX,X
  SUB ECX,[SUBX]
  CMP ECX,[MAXX]
  JA @EXT
  MOV EDX,Y
  SUB EDX,[SUBY]
  CMP EDX,[MAXY]
  JA @EXT
  MOV EAX,[WIDTH]
  ADD EDX,[ADDY]
  MUL EDX
  ADD ECX,[ADDX]
  ADD EAX,ECX
  ADD EAX,[BUFFER]
  MOV EAX,[EAX]
 @EXT:
END;
PROCEDURE PUT_B8(X,Y:LONGINT;C:DWORD);ASSEMBLER;
ASM
  MOV EAX,[VIS]
  OR EAX,EAX
  JZ @EXT
  MOV ECX,X
  SUB ECX,[SUBX]
  CMP ECX,[MAXX]
  JA @EXT
  MOV EDX,Y
  SUB EDX,[SUBY]
  CMP EDX,[MAXY]
  JA @EXT
  MOV EAX,[WIDTH]
  ADD EDX,[ADDY]
  MUL EDX
  ADD ECX,[ADDX]
  ADD EAX,ECX
  ADD EAX,[BUFFER]
  MOV EBX,[C]
  MOV [EAX],BL
 @EXT:
END;
PROCEDURE FILL_B8(C:DWORD);ASSEMBLER;
ASM
  MOV EDI,[BUFFER]
  MOV ECX,[PIXELS]
  SHR ECX,2
  MOV AL,BYTE PTR C
  MOV AH,AL
  MOV BX,AX
  SHL EAX,16
  MOV AX,BX
  REP STOSD
END;
