UNIT PICBAS;
INTERFACE
USES ALLBAS,GRAPH,FILES;
TYPE PEPICTURE=^TEPICTURE;
     TEPICTURE=OBJECT
      PROCEDURE BUFNORMAL;
      PROCEDURE BUFSMOOTH(H,B:DWORD;SX,SY:LONGINT;SH,SB:DWORD);
      PROCEDURE BUFSMOOTHIDEAL(NH,NB:DWORD;DPIY:REAL;SX,SY:LONGINT;SH,SB:DWORD);
      CONSTRUCTOR CREATE;
      CONSTRUCTOR CREATE(H,B:DWORD);
      PROCEDURE RELEASE;
      FUNCTION ALLOCATE(H,B:DWORD):BOOLEAN;
      DESTRUCTOR DESTROY;
      FUNCTION COMPARETO(P:PEPICTURE):BOOLEAN;
      FUNCTION LOAD(FN:STRING):BOOLEAN;
      FUNCTION SAVE(FN:STRING):BOOLEAN;
      PROCEDURE SELECTFORMAT(F:STRING);
      FUNCTION GETPIXEL(X,Y:LONGINT):DWORD;
      PROCEDURE PUTPIXEL(X,Y:LONGINT;C:DWORD);
      PROCEDURE SIMPSHOW(X,Y:LONGINT);
      FUNCTION GETHEIGHT:DWORD;
      FUNCTION GETWIDTH:DWORD;
      PROCEDURE SHOWCENTER(X,Y:LONGINT;H,B:DWORD);
      FUNCTION GETK(X,Y:LONGINT;P:DWORD):DWORD;
      FUNCTION GET(X,Y:LONGINT):DWORD;
      FUNCTION EXTRIDEAL(VAR X,Y:LONGINT;VAR H,B:DWORD;NH,NB:DWORD;DPIY:REAL;SX,SY:LONGINT;SH,SB:DWORD):DWORD;
      FUNCTION GETDATA:PDWORDARR;
      PROCEDURE SETCOLORM(R,G,B:DWORD);
      PROCEDURE GETCOLORM(VAR R,G,B:DWORD);
      PRIVATE
      HEIGHT:DWORD;
      WIDTH:DWORD;
      DATA:PDWORDARR;
      FORMAT:STRING;
      BUFFER:PPICTURE;
      REDM,GREENM,BLUEM:DWORD;
     END;
TYPE TPICFORMAT_LOAD=FUNCTION(P:PEPICTURE;F:PRFILE):BOOLEAN;
TYPE TPICFORMAT_SAVE=FUNCTION(P:PEPICTURE;F:PWFILE):BOOLEAN;
PROCEDURE REGISTERFORMAT(FR:STRING;LD:TPICFORMAT_LOAD;SV:TPICFORMAT_SAVE);
IMPLEMENTATION
USES DOS;
TYPE PPICFORMAT=^TPICFORMAT;
     TPICFORMAT=RECORD
      FORMAT:STRING;
      LOAD:TPICFORMAT_LOAD;
      SAVE:TPICFORMAT_SAVE;
      NEXT,LAST:PPICFORMAT;
     END;
VAR FIRSTFORMAT:PPICFORMAT;
PROCEDURE TEPICTURE.GETCOLORM(VAR R,G,B:DWORD);
BEGIN
 R:=REDM;
 G:=GREENM;
 B:=BLUEM;
END;
PROCEDURE TEPICTURE.SETCOLORM(R,G,B:DWORD);
BEGIN
 REDM:=R;
 GREENM:=G;
 BLUEM:=B;
END;
FUNCTION TEPICTURE.GETDATA:PDWORDARR;
BEGIN
 GETDATA:=DATA;
END;
FUNCTION TEPICTURE.EXTRIDEAL(VAR X,Y:LONGINT;VAR H,B:DWORD;NH,NB:DWORD;DPIY:REAL;SX,SY:LONGINT;SH,SB:DWORD):DWORD;
VAR LH,LB:DWORD;
BEGIN
 IF DATA=NIL THEN EXIT;
 IF NB*SH*DPIY>NH*SB THEN
 BEGIN
  LH:=NH;
  LB:=ROUND(SB*NH/(SH*DPIY));
 END
 ELSE
 BEGIN
  LH:=ROUND(SH*NB*DPIY/SB);
  LB:=NB;
 END;
 IF (LH=0) OR (LB=0) THEN
 BEGIN
  X:=0;
  Y:=0;
  H:=HEIGHT;
  B:=WIDTH;
  EXIT;
 END;
 DEC(X,(NB-LB) DIV 2);
 DEC(Y,(NH-LH) DIV 2);
 X:=SX+ROUND(X*(SB/LB));
 Y:=SY+ROUND(Y*(SH/LH));
 H:=ROUND(H*(SH/LH));
 B:=ROUND(B*(SB/LB));
 IF X<0 THEN
 BEGIN
  INC(B,X);
  X:=0;
 END;
 IF Y<0 THEN
 BEGIN
  INC(H,Y);
  Y:=0;
 END;
 IF Y+H>HEIGHT THEN H:=HEIGHT-Y;
 IF X+B>WIDTH THEN B:=WIDTH-X;
 IF LONGINT(H)<1 THEN H:=1;
 IF LONGINT(B)<1 THEN B:=1;
END;
PROCEDURE TEPICTURE.BUFSMOOTHIDEAL(NH,NB:DWORD;DPIY:REAL;SX,SY:LONGINT;SH,SB:DWORD);
VAR H,B:DWORD;
BEGIN
 IF (SH=0) OR (SB=0) THEN EXIT;
 IF NB*SH*DPIY>NH*SB THEN
 BEGIN
  H:=NH;
  B:=ROUND(SB*NH/(SH*DPIY));
 END
 ELSE
 BEGIN
  H:=ROUND(SH*NB*DPIY/SB);
  B:=NB;
 END;
 BUFSMOOTH(H,B,SX,SY,SH,SB);
END;
PROCEDURE TEPICTURE.BUFSMOOTH(H,B:DWORD;SX,SY:LONGINT;SH,SB:DWORD);
VAR MX,ADDX,ADDY,X,Y:REAL;
    LX,LY,RX,RY:LONGINT;
    AKTC0,AKTC1,AKTC2,ADDC0,ADDC1,ADDC2:REAL;
    LEFTC0,LEFTC1,LEFTC2:REAL;
    RIGTHC0,RIGTHC1,RIGTHC2:REAL;
    DSTX,DSTY,RDSTY:REAL;
    C1,C2,PO,I,N,ADDRY1,ADDRY2:DWORD;
    T1,T2:DWORD;
    H1,M1,S1,HS1:WORD;
    H2,M2,S2,HS2:WORD;
    MIN:BOOLEAN;
    I2,C:DWORD;
    PP:PBYTEARR;
BEGIN
 IF (H=0) OR (B=0) OR (DATA=NIL) THEN EXIT;
 IF SX<0 THEN INC(SB,SX);
 IF SY<0 THEN INC(SH,SY);
 IF LONGINT(SX+SB)>WIDTH THEN SB:=WIDTH-SX;
 IF LONGINT(SY+SH)>HEIGHT THEN SH:=HEIGHT-SY;
 IF (LONGINT(SB)<=0) OR (LONGINT(SH)<=0) THEN EXIT;
 IF BUFFER<>NIL THEN FREEPICTUREMD(BUFFER);
 CREATEPICTUREMD(BUFFER,H,B);
 GETTIME(H1,M1,S1,HS1);
 PP:=@BUFFER^.P;
 MX:=B/SB;
 MIN:=MX<1;
 ADDX:=SB/B;
 ADDY:=SH/H;
 Y:=SY+0.5;
 LY:=0;
 PO:=0;
 ADDRY1:=0;
 FOR I:=0 TO H-1 DO
 BEGIN
  X:=SX+0.5;
  LX:=0;
  DSTY:=FRAC(Y);
  RDSTY:=1-DSTY;
  RY:=TRUNC(Y);
  RX:=TRUNC(X);
  IF RY=0 THEN ADDRY1:=0 ELSE ADDRY1:=(RY-1)*WIDTH;
  IF RY<HEIGHT THEN ADDRY2:=RY*WIDTH ELSE ADDRY2:=(HEIGHT-1)*WIDTH;
  C1:=DATA^[ADDRY1+RX];
  C2:=DATA^[ADDRY2+RX];
  RIGTHC0:=(C1 AND $FF)*RDSTY+(C2 AND $FF)*DSTY;
  RIGTHC1:=(C1 SHR 8 AND $FF)*RDSTY+(C2 SHR 8 AND $FF)*DSTY;
  RIGTHC2:=(C1 SHR 16 AND $FF)*RDSTY+(C2 SHR 16 AND $FF)*DSTY;
  ADDC0:=0;
  ADDC1:=0;
  ADDC2:=0;
  AKTC0:=RIGTHC0;
  AKTC1:=RIGTHC1;
  AKTC2:=RIGTHC2;
  FOR N:=0 TO B-1 DO
  BEGIN
   C:=CONV( (ROUND(AKTC0)*REDM SHR 16)
           +(ROUND(AKTC1)*GREENM SHR 16) SHL 8
           +(ROUND(AKTC2)*BLUEM SHR 16) SHL 16);
   FOR I2:=1 TO BYTESPERPIXEL DO
   BEGIN
    PP^[PO]:=C;
    C:=C SHR 8;
    INC(PO);
   END;
   X:=X+ADDX;
   RX:=TRUNC(X);
   IF RX<WIDTH THEN
   IF RX=LX THEN
   BEGIN
    AKTC0:=AKTC0+ADDC0;
    AKTC1:=AKTC1+ADDC1;
    AKTC2:=AKTC2+ADDC2;
   END
   ELSE
   BEGIN
    LEFTC0:=RIGTHC0;
    LEFTC1:=RIGTHC1;
    LEFTC2:=RIGTHC2;
    C1:=DATA^[ADDRY1+RX];
    C2:=DATA^[ADDRY2+RX];
    RIGTHC0:=(C1 AND $FF)*RDSTY+(C2 AND $FF)*DSTY;
    RIGTHC1:=(C1 SHR 8 AND $FF)*RDSTY+(C2 SHR 8 AND $FF)*DSTY;
    RIGTHC2:=(C1 SHR 16 AND $FF)*RDSTY+(C2 SHR 16 AND $FF)*DSTY;
    DSTX:=FRAC(X);
    IF MIN THEN
    BEGIN
     AKTC0:=(RIGTHC0+LEFTC0)/2;
     AKTC1:=(RIGTHC1+LEFTC1)/2;
     AKTC2:=(RIGTHC2+LEFTC2)/2;
    END
    ELSE
    BEGIN
     ADDC0:=(RIGTHC0-LEFTC0)/MX;
     ADDC1:=(RIGTHC1-LEFTC1)/MX;
     ADDC2:=(RIGTHC2-LEFTC2)/MX;
     AKTC0:=LEFTC0+DSTX*ADDC0;
     AKTC1:=LEFTC1+DSTX*ADDC1;
     AKTC2:=LEFTC2+DSTX*ADDC2;
    END;
    LX:=RX;
   END;
  END;
  Y:=Y+ADDY;
 END;
 GETTIME(H2,M2,S2,HS2);
 T1:=((((H1*60)+M1)*60)+S1)*100+HS1;
 T2:=((((H2*60)+M2)*60)+S2)*100+HS2;
 WRITELN('Time for BUFSMOOTH : ',T2-T1);
END;
FUNCTION TEPICTURE.GET(X,Y:LONGINT):DWORD;
BEGIN
 IF (DWORD(X)<WIDTH) AND (DWORD(Y)<HEIGHT) THEN
 BEGIN
  GET:=DATA^[Y*WIDTH+X];
 END ELSE GET:=0;
END;
FUNCTION TEPICTURE.GETK(X,Y:LONGINT;P:DWORD):DWORD;
BEGIN
 IF (DWORD(X)<WIDTH) AND (DWORD(Y)<HEIGHT) THEN
 BEGIN
  GETK:=(DATA^[Y*WIDTH+X] SHR (P*8)) AND $FF;
 END ELSE GETK:=0;
END;
PROCEDURE TEPICTURE.SHOWCENTER(X,Y:LONGINT;H,B:DWORD);
BEGIN
 IF BUFFER<>NIL THEN PUTPIC(X+LONGINT(B-BUFFER^.B) DIV 2,Y+LONGINT(H-BUFFER^.H) DIV 2,BUFFER);
END;
PROCEDURE TEPICTURE.BUFNORMAL;
VAR I,N:DWORD;
BEGIN
 IF BUFFER<>NIL THEN FREEPICTUREMD(BUFFER);
 CREATEPICTUREMD(BUFFER,HEIGHT,WIDTH);
 FOR I:=0 TO HEIGHT-1 DO
 BEGIN
  FOR N:=0 TO WIDTH-1 DO
  BEGIN
   PICTUREMD_PUT(BUFFER,N,I,DATA^[I*WIDTH+N]);
  END;
 END;
END;
FUNCTION TEPICTURE.GETHEIGHT:DWORD;
BEGIN
 GETHEIGHT:=HEIGHT;
END;
FUNCTION TEPICTURE.GETWIDTH:DWORD;
BEGIN
 GETWIDTH:=WIDTH;
END;
PROCEDURE TEPICTURE.SIMPSHOW(X,Y:LONGINT);
VAR I,N:DWORD;
BEGIN
 IF DATA=NIL THEN EXIT;
 FOR I:=0 TO HEIGHT-1 DO
 BEGIN
  FOR N:=0 TO WIDTH-1 DO
  BEGIN
   GRAPH.PUT(N,I,CONV(DATA^[I*WIDTH+N]));
  END;
 END;
END;
PROCEDURE TEPICTURE.PUTPIXEL(X,Y:LONGINT;C:DWORD);
BEGIN
 IF (DWORD(X)<WIDTH) AND (DWORD(Y)<HEIGHT) THEN DATA^[Y*WIDTH+X]:=C;
END;
FUNCTION TEPICTURE.GETPIXEL(X,Y:LONGINT):DWORD;
BEGIN
 IF (DWORD(X)<WIDTH) AND (DWORD(Y)<HEIGHT) THEN
 BEGIN
  GETPIXEL:=DATA^[Y*WIDTH+X] AND $FFFFFF;
 END ELSE GETPIXEL:=$FFFFFFFF;
END;
PROCEDURE TEPICTURE.SELECTFORMAT(F:STRING);
BEGIN
 FORMAT:=F;
END;
FUNCTION FINDFORMAT_LOAD(FORMAT:STRING;PIC:PEPICTURE;F:PRFILE):BOOLEAN;
VAR P:PPICFORMAT;
BEGIN
 P:=FIRSTFORMAT;
 WHILE P<>NIL DO
 BEGIN
  IF (P^.FORMAT=FORMAT) AND (P^.LOAD<>NIL) THEN
  BEGIN
   PIC^.FORMAT:=FORMAT;
   FINDFORMAT_LOAD:=P^.LOAD(PIC,F);
   EXIT;
  END;
  P:=P^.NEXT;
 END;
 FINDFORMAT_LOAD:=FALSE;
END;
FUNCTION FINDFORMAT_SAVE(FORMAT:STRING;PIC:PEPICTURE;F:PWFILE):BOOLEAN;
VAR P:PPICFORMAT;
BEGIN
 P:=FIRSTFORMAT;
 WHILE P<>NIL DO
 BEGIN
  IF (P^.FORMAT=FORMAT) AND (P^.SAVE<>NIL) THEN
  BEGIN
   FINDFORMAT_SAVE:=P^.SAVE(PIC,F);
  END;
  P:=P^.NEXT;
 END;
 FINDFORMAT_SAVE:=FALSE;
END;
FUNCTION TEPICTURE.LOAD(FN:STRING):BOOLEAN;
VAR DIR,FILEN,EXT:STRING;
    PRD:PRFILE;
    PRD2:PRFILE;
BEGIN
 FSPLIT(FN,DIR,FILEN,EXT);
 NEW(PRD,INIT(FN));
 IF PRD=NIL THEN
 BEGIN
  LOAD:=FALSE;
  EXIT;
 END;
 EXT:=UPSTR(EXT);
 IF EXT='.PIC' THEN
 BEGIN
  EXT:=PRD^.READS;
  IF EXT='KCCMPIC1' THEN
  BEGIN
   LOAD:=FINDFORMAT_LOAD(PRD^.READS,@SELF,PRD);
  END
  ELSE
  BEGIN
   PRD^.SEEK(0);
   LOAD:=FINDFORMAT_LOAD('.PIC',@SELF,PRD);
  END;
 END ELSE LOAD:=FINDFORMAT_LOAD(EXT,@SELF,PRD);
 DISPOSE(PRD,DONE);
END;
FUNCTION TEPICTURE.SAVE(FN:STRING):BOOLEAN;
VAR PWR:PWFILE;
    DIR,FILEN,EXT:STRING;
BEGIN
 IF DATA=NIL THEN
 BEGIN
  SAVE:=FALSE;
  EXIT;
 END;
 FSPLIT(FN,DIR,FILEN,EXT);
 NEW(PWR,INIT(FN));
 IF PWR=NIL THEN
 BEGIN
  SAVE:=FALSE;
  EXIT;
 END;
 EXT:=UPSTR(EXT);
 IF (EXT='.PIC') AND (FORMAT<>'.PIC') THEN
 BEGIN
  PWR^.WRITES('KCCMPIC1');
  PWR^.WRITES(FORMAT);
  SAVE:=FINDFORMAT_SAVE(FORMAT,@SELF,PWR);
 END ELSE SAVE:=FINDFORMAT_SAVE(FORMAT,@SELF,PWR);
 DISPOSE(PWR,DONE);
END;
FUNCTION TEPICTURE.ALLOCATE(H,B:DWORD):BOOLEAN;
BEGIN
 RELEASE;
 GETMEM(DATA,H*B*4);
 HEIGHT:=H;
 WIDTH:=B;
 ALLOCATE:=(DATA<>NIL);
END;
PROCEDURE TEPICTURE.RELEASE;
BEGIN
 IF DATA<>NIL THEN
 BEGIN
  FREEMEM(DATA,HEIGHT*WIDTH*4);
  DATA:=NIL;
 END;
 IF BUFFER<>NIL THEN FREEPICTUREMD(BUFFER);
END;
FUNCTION TEPICTURE.COMPARETO(P:PEPICTURE):BOOLEAN;
VAR I,N:DWORD;
BEGIN
 IF (DATA=NIL) OR (P^.DATA=NIL) OR
    (HEIGHT<>P^.HEIGHT) OR (WIDTH<>P^.WIDTH) THEN
 BEGIN
  COMPARETO:=FALSE;
  EXIT;
 END;
 FOR I:=0 TO HEIGHT-1 DO
 BEGIN
  FOR N:=0 TO WIDTH-1 DO
  BEGIN
   IF DATA^[I*WIDTH+N]<>P^.DATA^[I*WIDTH+N] THEN
   BEGIN
    COMPARETO:=FALSE;
    EXIT;
   END;
  END;
 END;
 COMPARETO:=TRUE;
END;
CONSTRUCTOR TEPICTURE.CREATE;
BEGIN
 DATA:=NIL;
 BUFFER:=NIL;
 REDM:=65536;
 GREENM:=65536;
 BLUEM:=65536;
END;
CONSTRUCTOR TEPICTURE.CREATE(H,B:DWORD);
BEGIN
 { Ein Bild der Gre 0 ist illegal ! }
 REDM:=65536;
 GREENM:=65536;
 BLUEM:=65536;
 DATA:=NIL;
 BUFFER:=NIL;
 GETMEM(DATA,H*B*4);
 HEIGHT:=H;
 WIDTH:=B;
 FORMAT:='';
 IF DATA=NIL THEN FAIL;
END;
DESTRUCTOR TEPICTURE.DESTROY;
BEGIN
 IF DATA<>NIL THEN
 BEGIN
  FREEMEM(DATA,HEIGHT*WIDTH*4);
  DATA:=NIL;
 END;
 IF BUFFER<>NIL THEN FREEPICTUREMD(BUFFER);
END;
PROCEDURE REGISTERFORMAT(FR:STRING;LD:TPICFORMAT_LOAD;SV:TPICFORMAT_SAVE);
VAR P:PPICFORMAT;
BEGIN
 { Kein Lock Implementiert ! }
 NEW(P);
 P^.NEXT:=FIRSTFORMAT;
 P^.LAST:=NIL;
 IF FIRSTFORMAT<>NIL THEN FIRSTFORMAT^.LAST:=P;
 FIRSTFORMAT:=P;
 P^.FORMAT:=FR;
 P^.LOAD:=LD;
 P^.SAVE:=SV;
END;
END.
