UNIT PIC_PI;
INTERFACE
IMPLEMENTATION
{$I-}
USES ALLBAS,PICBAS,MENGEN,FILES;
CONST CONTDISTS:ARRAY[0..3,0..7] OF LONGINT=((0,1,3,7,15,31,63,131071),
 (0,3,15,131071,0,0,0,0),
 (3,131071,0,0,0,0,0,0),
 (15,131071,0,0,0,0,0,0));
CONST CONTDISTSL:ARRAY[0..3] OF DWORD=(7,3,1,1);
CONST RICHTUNGX:ARRAY[0..3] OF LONGINT=(0,-1,1,0);
CONST RICHTUNGY:ARRAY[0..3] OF LONGINT=(-1,0,0,1);
VAR TXT:TEXT;
    BC:DWORD;
TYPE PPRPOINT=^TPRPOINT;
     TPRPOINT=RECORD
      X,Y:LONGINT;
      PRIO:DWORD;
      NEXT,LAST:PPRPOINT;
     END;
TYPE PPRARR=^TPRARR;
     TPRARR=ARRAY[0..99999] OF TPRPOINT;
TYPE PCONTRASTMAP=^TCONTRASTMAP;
     TCONTRASTMAP=OBJECT
      CONSTRUCTOR INIT;
      PROCEDURE COMPRESS(P:PEPICTURE;W:PWFILE);
      PROCEDURE DECOMPRESS(P:PEPICTURE;R:PRFILE);
      DESTRUCTOR DONE;
      PROCEDURE DISPLAY(R,M:DWORD);
      PRIVATE
      FUNCTION ISKONT(X,Y:LONGINT;R,L:DWORD):BOOLEAN;
      FUNCTION GETKONTLEV(X,Y:LONGINT;R:DWORD):DWORD;
      PROCEDURE WRITEC;
      PROCEDURE FLOOD;
      PROCEDURE PUTK(X,Y:LONGINT;P,C:DWORD);
      FUNCTION GETK(X,Y:LONGINT;P:DWORD):DWORD;
      FUNCTION KONTLEV(X1,Y1,X2,Y2:LONGINT):DWORD;
      FUNCTION KONTLEVK(X1,Y1,X2,Y2:LONGINT;P:DWORD):DWORD;
      PROCEDURE UPDATEINTV(VAR MEN:TMENGE;X,Y:LONGINT;R,P:DWORD);
      PROCEDURE DOPOINT(X,Y:LONGINT);
      PROCEDURE DOPOINTK(X,Y:LONGINT;P:DWORD);
      PROCEDURE ADDTABE(X,Y:LONGINT;P:DWORD);
      PROCEDURE INITTABE;
      PROCEDURE DONETABE;
      PROCEDURE FLOODPOINT(X,Y:LONGINT);
      PROCEDURE GETTABE(VAR X,Y:LONGINT);
      PROCEDURE WRITECB(X,Y:LONGINT;H,B:DWORD);
      PROCEDURE WRITECBR(X,Y:LONGINT;H,B,R:DWORD);
      PROCEDURE READC;
      PROCEDURE READCB(X,Y:LONGINT;H,B:DWORD);
      PROCEDURE READCBR(X,Y:LONGINT;H,B,R:DWORD);
      PROCEDURE ALLOCKONT;
      PROCEDURE RELEASEKONT;
      PROCEDURE RESETKONT;
      PROCEDURE SETKONTLEV(X,Y:LONGINT;R,V:DWORD);
      PROCEDURE DETECTBLACKWHITE;
      PIC:PDWORDARR;
      HI,WI:DWORD;
      KONT:ARRAY[0..3] OF PBYTEARR;
      PRP:PPRARR;
      PRPL:ARRAY[0..7] OF PPRPOINT;
      KNOWN:PBYTEARR;
      WF:PWFILE;
      RF:PRFILE;
      READF:BOOLEAN;
      TESTF:BOOLEAN;
      BLACKWHITE:BOOLEAN;
      CONTDIST:ARRAY[0..7] OF LONGINT;
      CONTDISTL:DWORD;
      CONTDISTB:DWORD;
     END;
VAR DEBBITS:ARRAY[0..8] OF DWORD;
PROCEDURE TCONTRASTMAP.DETECTBLACKWHITE;
VAR I,N:DWORD;
    C:DWORD;
BEGIN
 FOR I:=0 TO HI-1 DO
 BEGIN
  FOR N:=0 TO WI-1 DO
  BEGIN
   C:=GETK(N,I,0);
   IF (C<>GETK(N,I,1)) OR (C<>GETK(N,I,2)) THEN
   BEGIN
    BLACKWHITE:=FALSE;
    EXIT;
   END;
  END;
 END;
 BLACKWHITE:=TRUE;
END;
PROCEDURE TCONTRASTMAP.PUTK(X,Y:LONGINT;P,C:DWORD);
BEGIN
 IF (DWORD(X)<WI) AND (DWORD(Y)<HI) THEN
 BEGIN
  PIC^[Y*WI+X]:=PIC^[Y*WI+X] AND (NOT ($FF SHL (P*8)));
  PIC^[Y*WI+X]:=PIC^[Y*WI+X] OR (C AND $FF SHL (P*8));
 END;
END;
PROCEDURE TCONTRASTMAP.SETKONTLEV(X,Y:LONGINT;R,V:DWORD);
BEGIN
 KONT[R]^[Y*WI+X]:=V;
 KONT[3-R]^[(RICHTUNGY[R]+Y)*WI+RICHTUNGX[R]+X]:=V;
END;
PROCEDURE TCONTRASTMAP.RESETKONT;
VAR I:DWORD;
BEGIN
 FILLCHAR(KONT[0]^,HI*WI,0);
 FILLCHAR(KONT[1]^,HI*WI,0);
 FILLCHAR(KONT[2]^,HI*WI,0);
 FILLCHAR(KONT[3]^,HI*WI,0);
 FOR I:=0 TO HI-1 DO
 BEGIN
  KONT[1]^[I*WI]:=8;
  KONT[2]^[(I+1)*WI-1]:=8;
 END;
 FOR I:=0 TO WI-1 DO
 BEGIN
  KONT[0]^[I]:=8;
  KONT[3]^[(HI-1)*WI+I]:=8;
 END;
END;
PROCEDURE TCONTRASTMAP.ALLOCKONT;
BEGIN
 GETMEM(KONT[0],HI*WI);
 GETMEM(KONT[1],HI*WI);
 GETMEM(KONT[2],HI*WI);
 GETMEM(KONT[3],HI*WI);
END;
PROCEDURE TCONTRASTMAP.RELEASEKONT;
BEGIN
 FREEMEM(KONT[0],HI*WI);
 FREEMEM(KONT[1],HI*WI);
 FREEMEM(KONT[2],HI*WI);
 FREEMEM(KONT[3],HI*WI);
END;
CONSTRUCTOR TCONTRASTMAP.INIT;
BEGIN
END;
PROCEDURE TCONTRASTMAP.FLOODPOINT(X,Y:LONGINT);
VAR I:DWORD;
BEGIN
 IF KNOWN^[Y*WI+X] AND 1<>0 THEN EXIT;
 KNOWN^[Y*WI+X]:=KNOWN^[Y*WI+X] OR 1;
 DOPOINT(X,Y);
 { Jetzt mu noch die Prio-Tab erledigt werden ! }
 ADDTABE(X,Y-1,GETKONTLEV(X,Y,0));
 ADDTABE(X-1,Y,GETKONTLEV(X,Y,1));
 ADDTABE(X+1,Y,GETKONTLEV(X,Y,2));
 ADDTABE(X,Y+1,GETKONTLEV(X,Y,3));
END;
PROCEDURE TCONTRASTMAP.GETTABE(VAR X,Y:LONGINT);
VAR P:DWORD;
    A:PPRPOINT;
BEGIN
 P:=0;
 WHILE P<8 DO
 BEGIN
  A:=PRPL[P];
  IF A<>NIL THEN
  BEGIN
   X:=A^.X;
   Y:=A^.Y;
   IF A^.NEXT<>NIL THEN A^.NEXT^.LAST:=NIL;
   PRPL[P]:=A^.NEXT;
   EXIT;
  END;
  INC(P);
 END;
 X:=$FFFFFFFF;
END;
PROCEDURE TCONTRASTMAP.FLOOD;
VAR X,Y:LONGINT;
BEGIN
 INITTABE;
 FLOODPOINT(0,0);
 REPEAT
  GETTABE(X,Y);
  IF X<>$FFFFFFFF THEN FLOODPOINT(X,Y);
 UNTIL (X=$FFFFFFFF);
 DONETABE;
END;
PROCEDURE TCONTRASTMAP.DONETABE;
BEGIN
 FREEMEM(PRP,SIZEOF(TPRPOINT)*HI*WI);
END;
PROCEDURE TCONTRASTMAP.INITTABE;
VAR I,N:DWORD;
BEGIN
 GETMEM(PRP,SIZEOF(TPRPOINT)*HI*WI);
 FILLCHAR(PRPL,SIZEOF(PRPL),0);
 FOR I:=0 TO HI-1 DO
 BEGIN
  FOR N:=0 TO WI-1 DO
  BEGIN
   PRP^[I*WI+N].PRIO:=8;
   PRP^[I*WI+N].X:=N;
   PRP^[I*WI+N].Y:=I;
  END;
 END;
END;
PROCEDURE TCONTRASTMAP.ADDTABE(X,Y:LONGINT;P:DWORD);
VAR PT:PPRPOINT;
BEGIN
 IF P>8 THEN WRITELN(TXT,'Was solln das ?');
 IF (P<8) AND (KNOWN^[Y*WI+X] AND 1=0) THEN
 BEGIN
  PT:=@PRP^[Y*WI+X];
  IF PT^.PRIO>P THEN
  BEGIN
   IF PT^.PRIO<>8 THEN
   BEGIN
    IF PT^.LAST<>NIL THEN
    BEGIN
     PT^.LAST^.NEXT:=PT^.NEXT;
    END ELSE PRPL[PT^.PRIO]:=PT^.NEXT;
    IF PT^.NEXT<>NIL THEN PT^.NEXT^.LAST:=PT^.LAST;
   END;
   PT^.PRIO:=P;
   PT^.NEXT:=PRPL[P];
   PT^.LAST:=NIL;
   IF PRPL[P]<>NIL THEN PRPL[P]^.LAST:=PT;
   PRPL[P]:=PT;
  END;
 END;
END;
PROCEDURE TCONTRASTMAP.DOPOINTK(X,Y:LONGINT;P:DWORD);
VAR MEN:TMENGE;
    BITS:DWORD;
    C:DWORD;
BEGIN
 MEN.RESET(0,255);
 UPDATEINTV(MEN,X,Y-1,3,P);
 UPDATEINTV(MEN,X-1,Y,2,P);
 UPDATEINTV(MEN,X+1,Y,1,P);
 UPDATEINTV(MEN,X,Y+1,0,P);
 BITS:=NEEDBITS(MEN.SIZE);
 INC(DEBBITS[BITS]);
 IF READF THEN
 BEGIN
  C:=MEN.DECODE(RF^.READ(BITS));
  IF BLACKWHITE THEN
  BEGIN
   PUTK(X,Y,0,C);
   PUTK(X,Y,1,C);
   PUTK(X,Y,2,C);
  END ELSE PUTK(X,Y,P,C);
 END ELSE
 BEGIN
  IF NOT TESTF THEN WF^.WRITE(MEN.CODE(GETK(X,Y,P)),BITS);
 END;
END;
PROCEDURE TCONTRASTMAP.DOPOINT(X,Y:LONGINT);
BEGIN
 INC(BC);
 DOPOINTK(X,Y,0);
 IF NOT BLACKWHITE THEN
 BEGIN
  DOPOINTK(X,Y,1);
  DOPOINTK(X,Y,2);
 END;
 KNOWN^[Y*WI+X]:=KNOWN^[Y*WI+X] OR 128;
END;
PROCEDURE TCONTRASTMAP.UPDATEINTV(VAR MEN:TMENGE;X,Y:LONGINT;R,P:DWORD);
VAR D:LONGINT;
    C:LONGINT;
    K:DWORD;
BEGIN
 IF (DWORD(X)<WI) AND (DWORD(Y)<HI) AND (KNOWN^[Y*WI+X] AND 128<>0) THEN
 BEGIN
  K:=KONT[R]^[Y*WI+X];
  D:=CONTDIST[KONT[R]^[Y*WI+X]];
  C:=GETK(X,Y,P);
  MEN.REDUCE(C-D,C+D);
 END;
END;
FUNCTION TCONTRASTMAP.GETKONTLEV(X,Y:LONGINT;R:DWORD):DWORD;
BEGIN
 GETKONTLEV:=KONT[R]^[Y*WI+X];
END;
FUNCTION TCONTRASTMAP.ISKONT(X,Y:LONGINT;R,L:DWORD):BOOLEAN;
BEGIN
 ISKONT:=KONT[R]^[Y*WI+X]>L;
END;
PROCEDURE TCONTRASTMAP.DISPLAY(R,M:DWORD);
VAR I,N:DWORD;
BEGIN
 { Die Rnder sollten Blau erscheinen ! }
 FOR I:=0 TO HI-1 DO
 BEGIN
  FOR N:=0 TO WI-1 DO
  BEGIN
   IF KONT[R]^[I*WI+N]>M THEN
   BEGIN
    IF KONT[R]^[I*WI+N]=8 THEN
    BEGIN
    { GRAPH.PUT(N,I,CL_BLUE);}
    END{ ELSE GRAPH.PUT(N,I,CONV(KONT[R]^[I*WI+N]*64))};
   END;
  END;
 END;
{ GRAPH.COPY(0);}
END;
FUNCTION TCONTRASTMAP.KONTLEVK(X1,Y1,X2,Y2:LONGINT;P:DWORD):DWORD;
VAR D:LONGINT;
BEGIN
 IF (DWORD(X2)<WI) AND (DWORD(Y2)<HI) THEN
 BEGIN
  D:=ABS(LONGINT(GETK(X1,Y1,P)-GETK(X2,Y2,P)));
  KONTLEVK:=0;
  WHILE (CONTDIST[KONTLEVK]<D) DO INC(KONTLEVK);
  { Es sind nur 7 Levels zulssig, wenn es sich nicht um einen Rand handelt ! }
  IF KONTLEVK>CONTDISTL THEN KONTLEVK:=CONTDISTL;
 END ELSE KONTLEVK:=8; { Rand ! }
END;
FUNCTION TCONTRASTMAP.KONTLEV(X1,Y1,X2,Y2:LONGINT):DWORD;
VAR K:DWORD;
BEGIN
 KONTLEV:=0; { Limit of the Map ! (Full Surface...) }
 K:=KONTLEVK(X1,Y1,X2,Y2,0);
 IF K>KONTLEV THEN KONTLEV:=K;
 K:=KONTLEVK(X1,Y1,X2,Y2,1);
 IF K>KONTLEV THEN KONTLEV:=K;
 K:=KONTLEVK(X1,Y1,X2,Y2,2);
 IF K>KONTLEV THEN KONTLEV:=K;
END;
FUNCTION TCONTRASTMAP.GETK(X,Y:LONGINT;P:DWORD):DWORD;
BEGIN
 IF (DWORD(X)<WI) AND (DWORD(Y)<HI) THEN
 BEGIN
  GETK:=PIC^[Y*WI+X] SHR (P*8) AND $FF;
 END ELSE GETK:=$FFFF;
END;
DESTRUCTOR TCONTRASTMAP.DONE;
BEGIN
END;
CONST CONTMAP_BH=4;
      CONTMAP_BB=4;
VAR BITCOUNT:DWORD;
PROCEDURE TCONTRASTMAP.WRITECBR(X,Y:LONGINT;H,B,R:DWORD);
VAR I,N:DWORD;
    C,BAS:DWORD;
    LIM:DWORD;
    BITS:DWORD;
BEGIN
 LIM:=0;
 BAS:=GETKONTLEV(X,Y,R);
 FOR I:=0 TO H-1 DO
 BEGIN
  FOR N:=0 TO B-1 DO
  BEGIN
   C:=GETKONTLEV(X+N,Y+I,R);
   IF C<>8 THEN
   BEGIN
    IF C>BAS THEN
    BEGIN
     IF BAS+LIM<C THEN LIM:=C-BAS;
    END
    ELSE
    BEGIN
     INC(LIM,BAS-C);
     BAS:=C;
    END;
   END;
  END;
 END;
 BITS:=NEEDBITS(LIM+1);
 IF BITS<CONTDISTB THEN
 BEGIN
  INC(BITCOUNT,CONTDISTB*2+BITS*H*B);
  IF NOT TESTF THEN
  BEGIN
   WF^.WRITE(1,1);
   WF^.WRITE(BAS,CONTDISTB);
   WF^.WRITE(BITS,CONTDISTB-1);
   FOR I:=0 TO H-1 DO
   BEGIN
    FOR N:=0 TO B-1 DO
    BEGIN
     IF GETKONTLEV(X+N,Y+I,R)<>8 THEN WF^.WRITE(GETKONTLEV(X+N,Y+I,R)-BAS,BITS);
    END;
   END;
  END;
 END
 ELSE
 BEGIN
  INC(BITCOUNT,1+H*B*CONTDISTB);
  IF NOT TESTF THEN
  BEGIN
   WF^.WRITE(0,1);
   FOR I:=0 TO H-1 DO
   BEGIN
    FOR N:=0 TO B-1 DO
    BEGIN
     IF GETKONTLEV(X+N,Y+I,R)<>8 THEN WF^.WRITE(GETKONTLEV(X+N,Y+I,R),CONTDISTB);
    END;
   END;
  END;
 END;
END;
PROCEDURE TCONTRASTMAP.WRITECB(X,Y:LONGINT;H,B:DWORD);
BEGIN
 IF (H=0) OR (B=0) THEN EXIT;
 WRITECBR(X,Y,H,B,2);
 WRITECBR(X,Y,H,B,3);
END;
PROCEDURE TCONTRASTMAP.WRITEC;
VAR HB,BB:DWORD;
    HR,BR:DWORD;
    I,N:DWORD;
BEGIN
 HB:=HI DIV CONTMAP_BH;
 BB:=WI DIV CONTMAP_BB;
 HR:=HI MOD CONTMAP_BH;
 BR:=WI MOD CONTMAP_BB;
 FOR I:=0 TO HB-1 DO
 BEGIN
  FOR N:=0 TO BB-1 DO
  BEGIN
   WRITECB(N*CONTMAP_BB,I*CONTMAP_BH,CONTMAP_BH,CONTMAP_BB);
  END;
  WRITECB(WI-BR,I*CONTMAP_BH,CONTMAP_BH,BR);
 END;
 FOR N:=0 TO BB-1 DO
 BEGIN
  WRITECB(N*CONTMAP_BB,HI-HR,HR,CONTMAP_BB);
 END;
 WRITECB(WI-BR,HI-HR,HR,BR);
 WRITELN('Anzahl Bits fr die Kontrastlevels : ',BITCOUNT);
END;
PROCEDURE TCONTRASTMAP.READCBR(X,Y:LONGINT;H,B,R:DWORD);
VAR I,N:DWORD;
    BAS:DWORD;
    BITS:DWORD;
BEGIN
 IF RF^.READ(1)=1 THEN
 BEGIN
  BAS:=RF^.READ(CONTDISTB);
  BITS:=RF^.READ(CONTDISTB-1);
  FOR I:=0 TO H-1 DO
  BEGIN
   FOR N:=0 TO B-1 DO
   BEGIN
    IF GETKONTLEV(X+N,Y+I,R)<>8 THEN SETKONTLEV(X+N,Y+I,R,RF^.READ(BITS)+BAS);
   END;
  END;
 END
 ELSE
 BEGIN
  FOR I:=0 TO H-1 DO
  BEGIN
   FOR N:=0 TO B-1 DO
   BEGIN
    IF GETKONTLEV(X+N,Y+I,R)<>8 THEN SETKONTLEV(X+N,Y+I,R,RF^.READ(CONTDISTB));
   END;
  END;
 END;
END;
PROCEDURE TCONTRASTMAP.READCB(X,Y:LONGINT;H,B:DWORD);
BEGIN
 IF (H=0) OR (B=0) THEN EXIT;
 READCBR(X,Y,H,B,2);
 READCBR(X,Y,H,B,3);
END;
PROCEDURE TCONTRASTMAP.READC;
VAR HB,BB:DWORD;
    HR,BR:DWORD;
    I,N:DWORD;
BEGIN
 RESETKONT;
 HB:=HI DIV CONTMAP_BH;
 BB:=WI DIV CONTMAP_BB;
 HR:=HI MOD CONTMAP_BH;
 BR:=WI MOD CONTMAP_BB;
 FOR I:=0 TO HB-1 DO
 BEGIN
  FOR N:=0 TO BB-1 DO
  BEGIN
   READCB(N*CONTMAP_BB,I*CONTMAP_BH,CONTMAP_BH,CONTMAP_BB);
  END;
  READCB(WI-BR,I*CONTMAP_BH,CONTMAP_BH,BR);
 END;
 FOR N:=0 TO BB-1 DO
 BEGIN
  READCB(N*CONTMAP_BB,HI-HR,HR,CONTMAP_BB);
 END;
 READCB(WI-BR,HI-HR,HR,BR);
END;
PROCEDURE TCONTRASTMAP.COMPRESS(P:PEPICTURE;W:PWFILE);
VAR I,N:DWORD;
    C,T:DWORD;
    MIN:DWORD;
BEGIN
 WF:=W;
 PIC:=P^.GETDATA;
 HI:=P^.GETHEIGHT;
 WI:=P^.GETWIDTH;
 DETECTBLACKWHITE;
 WRITELN('PIC : ',HI,'*',WI,'=',HI*WI,'  Schwarzweiss : ',BLACKWHITE);
 { Grundlegende Daten schreiben }
 WF^.WRITE(HI,32);
 WF^.WRITE(WI,32);
 WF^.WRITE(BYTE(BLACKWHITE),1);
 { Ntiger Speicher fr die Kompression }
 ALLOCKONT;
 GETMEM(KNOWN,HI*WI);
 { Flaggen setzen }
 TESTF:=TRUE;
 READF:=FALSE;
 MIN:=$FFFFFFFF;
 FOR T:=0 TO 3 DO
 BEGIN
  BITCOUNT:=0;
  MOVE(CONTDISTS[T],CONTDIST,SIZEOF(CONTDIST));
  CONTDISTL:=CONTDISTSL[T];
  CONTDISTB:=NEEDBITS(CONTDISTL+1);
  FOR I:=0 TO HI-1 DO
  BEGIN
   FOR N:=0 TO WI-1 DO
   BEGIN
    KONT[0]^[I*WI+N]:=KONTLEV(N,I,N,I-1);
    KONT[1]^[I*WI+N]:=KONTLEV(N,I,N-1,I);
    KONT[2]^[I*WI+N]:=KONTLEV(N,I,N+1,I);
    KONT[3]^[I*WI+N]:=KONTLEV(N,I,N,I+1);
   END;
  END;
  WRITEC;
  FILLCHAR(KNOWN^,HI*WI,0);
  FILLCHAR(DEBBITS,SIZEOF(DEBBITS),0);
  BC:=0;
  FLOOD;
  FOR I:=1 TO 8 DO INC(BITCOUNT,DEBBITS[I]*I);
  IF BITCOUNT<MIN THEN
  BEGIN
   C:=T;
   MIN:=BITCOUNT;
  END;
 END;
 BITCOUNT:=0;
 MOVE(CONTDISTS[C],CONTDIST,SIZEOF(CONTDIST));
 CONTDISTL:=CONTDISTSL[C];
 CONTDISTB:=NEEDBITS(CONTDISTL+1);
 TESTF:=FALSE;
 WF^.WRITE(C,2);
 FOR I:=0 TO HI-1 DO
 BEGIN
  FOR N:=0 TO WI-1 DO
  BEGIN
   KONT[0]^[I*WI+N]:=KONTLEV(N,I,N,I-1);
   KONT[1]^[I*WI+N]:=KONTLEV(N,I,N-1,I);
   KONT[2]^[I*WI+N]:=KONTLEV(N,I,N+1,I);
   KONT[3]^[I*WI+N]:=KONTLEV(N,I,N,I+1);
  END;
 END;
 WRITEC;
 FILLCHAR(KNOWN^,HI*WI,0);
 FILLCHAR(DEBBITS,SIZEOF(DEBBITS),0);
 BC:=0;
 FLOOD;
 WRITELN('Bit-Nutzung :');
 FOR I:=0 TO 8 DO
 BEGIN
  WRITELN(I:3,' : ',DEBBITS[I]);
 END;
 FREEMEM(KNOWN,HI*WI);
 RELEASEKONT;
END;
PROCEDURE TCONTRASTMAP.DECOMPRESS(P:PEPICTURE;R:PRFILE);
VAR C:DWORD;
BEGIN
 RF:=R;
 HI:=RF^.READ(32);
 WI:=RF^.READ(32);
 BLACKWHITE:=BOOLEAN(RF^.READ(1));
 C:=RF^.READ(2);
 MOVE(CONTDISTS[C],CONTDIST,SIZEOF(CONTDIST));
 CONTDISTL:=CONTDISTSL[C];
 CONTDISTB:=NEEDBITS(CONTDISTL+1);
 WRITELN('Decompress Picture of ',HI,'*',WI,'=',HI*WI);
 P^.ALLOCATE(HI,WI);
 PIC:=P^.GETDATA;
 ALLOCKONT;
 { Kontraste Dekomprimieren }
 READC;
 { ... }
 READF:=TRUE;
 GETMEM(KNOWN,HI*WI);
 FILLCHAR(KNOWN^,HI*WI,0);
 { Flooding... }
 FLOOD;
 FREEMEM(KNOWN,HI*WI);
 RELEASEKONT;
END;
FUNCTION PI_LOAD(P:PEPICTURE;F:PRFILE):BOOLEAN;
VAR PI:PCONTRASTMAP;
BEGIN
 NEW(PI,INIT);
 PI^.DECOMPRESS(P,F);
 DISPOSE(PI,DONE);
 PI_LOAD:=TRUE;
END;
FUNCTION PI_SAVE(P:PEPICTURE;F:PWFILE):BOOLEAN;
VAR PI:PCONTRASTMAP;
BEGIN
 NEW(PI,INIT);
 PI^.COMPRESS(P,F);
 DISPOSE(PI,DONE);
 PI_SAVE:=TRUE;
END;
BEGIN
 REGISTERFORMAT('.PI',@PI_LOAD,@PI_SAVE);
END.
